package edu.cmu.cs211.snake.util;

import java.util.AbstractSet;
import java.util.Iterator;
import java.util.Set;
import java.util.NoSuchElementException;

//The docs are mostly the same as the Java 5 documentation, which have
//been copied and pasted from the shared source version, under the
//JRL: http://java.net/jrl.csp

/**
 * This class implements the Set interface, backed by a hash table. It makes no
 * guarantees as to the iteration order of the set; in particular, it does not
 * guarantee that the order will remain constant over time. This class permits
 * the null element.
 * <p>
 * This class offers constant time performance for the basic operations (<tt>add</tt>,
 * <tt>remove</tt>, <tt>contains</tt> and <tt>size</tt>), assuming the
 * hash function disperses the elements properly among the buckets.
 * <p>
 * 
 * There are a few important requirements for your impl. of this data structure:
 * <ul>
 * <li>You <em>must</em> support constant time operations</li>
 * <li>You <em>may not</em> use any collection classes from <code>java.util.*</code></li>
 * <li>You <em>must</em> resize your hashtable according to the load factor</li>
 * </ul>
 */
public class MyHashSet <E> extends AbstractSet <E> {

	private float loadFact;
	
	// a nice prime to start with (do not change this)
	private static final int DEFAULT_INITIAL_CAPACITY = 11;

	// a good load factor (do not change)
	private static final float DEFAULT_LOAD_FACTOR = 0.75f;

	/**
	 * Constructs a new, empty set; the backing table has default initial
	 * capacity (16) and load factor (0.75).
	 */
	public MyHashSet ()
	{
	}

	/**
	 * Constructs a new, empty set; the backing table has the specified initial
	 * capacity and default load factor, which is <tt>0.75</tt>.
	 * 
	 * @param initialCapacity
	 *            the initial capacity of the hash table.
	 * @throws IllegalArgumentException
	 *             if the initial capacity is less than zero.
	 */
	public MyHashSet (int initialCapacity) 
	{
	
	}

	/**
	 * Constructs a new, empty set; the table has the specified initial capacity
	 * and the specified load factor.
	 * 
	 * @param initialCapacity
	 *            the initial capacity of the hash map.
	 * @param loadFactor
	 *            the load factor of the hash map.
	 * @throws IllegalArgumentException
	 *             if the initial capacity is less than zero, or if the load
	 *             factor is nonpositive.
	 */
	public MyHashSet (int initialCapacity, float loadFactor)
	{
	}

	/**
	 * Returns an iterator over the elements in this set. The elements are
	 * returned in no particular order. You do <em>not</em> have to implement
	 * failfast behavior (ie, ConcurrentModificationException).
	 * 
	 * @return an Iterator over the elements in this set.
	 */
	private class HashIter<E> implements Iterator<E> {
		
		public boolean hasNext() 
		{
			return false;
		}
		
		public E next() 
		{
			return null;
		}
		
		public void remove() {
			return;
		}
	}
	
	@Override
	public Iterator <E> iterator ()
	{
		return new HashIter();
	}

	/**
	 * Returns the number of elements in this set (its cardinality).
	 * 
	 * @return the number of elements in this set (its cardinality).
	 */
	@Override
	public int size ()
	{
		return 0;
	}

	/**
	 * Returns <tt>true</tt> if this set contains the specified element.
	 * 
	 * @param o
	 *            element whose presence in this set is to be tested.
	 * @return <tt>true</tt> if this set contains the specified element.
	 */
	@Override
	public boolean contains (Object o)
	{
		return false;
	}
	
	/**
	 * Adds the specified element to this set if it is not already present.
	 * 
	 * @param e
	 *            element to be added to this set.
	 * @return <tt>true</tt> if the set did not already contain the specified
	 *         element.
	 */
	@Override
	public boolean add (E e)
	{
		return false;
	}

	/**
	 * Removes the specified element from this set if it is present.
	 * 
	 * @param o
	 *            object to be removed from this set, if present.
	 * @return <tt>true</tt> if the set contained the specified element.
	 */
	@Override
	public boolean remove (Object o)
	{
		return false;
	}

	/**
	 * Removes all of the elements from this set.
	 */
	@Override
	public void clear ()
	{
	
	}
}
